#!/bin/bash
#Linux:CentOS6.5
#MySQL:mysql5.6.20

#һЩҪı
RPM_DIR=/u01/rpm
MYSQL_INSTALL_DIR=/u01/mysql-5.6.20 #mysqlװļѹ·
MYSQL_DIR=/u01/app/mysql #mysqlװĿ¼
MYSQL_DATA_DIR=/u01/app/mysql/data #mysqlݿļ·

if [ ! -e $MYSQL_DATA_DIR ];then
   mkdir -p $MYSQL_DATA_DIR
fi

#uninstall mysqlжԭȵmysql
rpm -qa|grep mysql|xargs rpm -e --nodeps

#install rpm package װmysqlҪrpm(װЩrpmļȡӦø)
rpmPack=(make cmake bison bison-devel gcc gcc-c++ ncurses ncurses-devel)
for pack in ${rpmPack[*]}
do
  if(rpm -q $pack)
  then
     echo "$pack package is exists!"
  else
     if [ "$pack" = "cmake" ];then
        rpm -ivh $RPM_DIR/cmake-2.6.4-5.el6.x86_64.rpm
     elif [ "$pack" = "make" ];then
        rpm -ivh $RPM_DIR/make-3.81-20.el6.x86_64.rpm
     elif [ "bison" = "$pack" ];then
        rpm -ivh $RPM_DIR/bison-2.4.1-5.el6.x86_64.rpm
     elif [ "bison-devel" = "$pack" ];then
        rpm -ivh $RPM_DIR/bison-devel-2.4.1-5.el6.x86_64.rpm
     elif [ "gcc" = "$pack" ];then
        rpm -ivh $RPM_DIR/gcc-4.4.7-4.el6.x86_64.rpm
     elif [ "gcc-cc++" = "$pack" ];then
        rpm -ivh $RPM_DIR/gcc-c++-4.4.7-4.el6.x86_64.rpm
     elif [ "ncurses" = "$pack" ];then
        rpm -ivh $RPM_DIR/ncurses-5.7-3.20090208.el6.x86_64.rpm
     elif [ "ncurses-devel" = "$pack" ];then
        rpm -ivh $RPM_DIR/ncurses-devel-5.7-3.20090208.el6.x86_64.rpm
     fi
  fi
done

#install mysql
cd $MYSQL_INSTALL_DIR
cmake \
-DCMAKE_INSTALL_PREFIX=$MYSQL_DIR \
-DMYSQL_DATADIR=$MYSQL_DATA_DIR \
-DWITH_MYISAM_STORAGE_ENGINE=1 \
-DWITH_INNOBASE_STORAGE_ENGINE=1 \
-DWITH_MEMORY_STORAGE_ENGINE=1 \
-DWITH_PARTITION_STORAGE_ENGINE=1 \
-DWITH_READLINE=1 \
-DMYSQL_TCP_PORT=3306 \
-DENABLED_LOCAL_INFILE=1 \
-DEXTRA_CHARSETS=all \
-DDEFAULT_CHARSET=utf8 \
-DDEFAULT_COLLATION=utf8_general_ci

make && make install

#config
#add group mysql and user mysql
#ҪжûǷ
groupadd -g 720 mysql
useradd -u 520 -g mysql mysql

chown -R mysql:mysql $MYSQL_DIR

#initial mysql database
cd $MYSQL_DIR
$MYSQL_DIR/scripts/mysql_install_db --basedir=$MYSQL_DIR --datadir=$MYSQL_DATA_DIR --user=mysql

cp $MYSQL_DIR/support-files/mysql.server /etc/init.d/mysql
service mysql start
